.dseg



.cseg

.def omega_1rl=r2
.def omega_1rh=r3
.def phi_1rl=r4
.def phi_1rh=r5
.def volume_1r=r6
.def modf_1r=r7
.def modg_1r=r8
.def t1=r17

.def mul_h=r1
.def mul_l=r0



.macro audio_isr_prepare
    PUSH omega_1rl
    LDS omega_1rl,omega_1
    PUSH omega_1rh
    LDS omega_1rh,omega_1+1
    
    PUSH phi_1rl
    LDS phi_1rl,phi_1
    PUSH phi_1rh
    LDS phi_1rh,phi_1+1
    
    PUSH volume_1r
    LDS volume_1r,volume_1
    
    PUSH modf_1r
    LDS modf_1r,modf_1
    
    PUSH modg_1r
    LDS modg_1r,modg_1
    
    PUSH r1
    PUSH r0
    
.endmacro

.macro audio_isr_finish
    POP r0
    POP r1

    POP modg_1r

    POP modf_1r

    POP volume_1r
    
    STS phi_1,phi_1rl
    POP phi_1rl
    STS phi_1+1,phi_1rh
    POP phi_1rh
    
    POP omega_1rl
    POP omega_1rh
    
.endmacro


.macro audio_pm_15625Hz
    LDI zh,high(sintab*2)   	;1
    
    ADD phi_1rl,omega_1rl   	;1
    ADC phi_1rh,omega_1rh   	;1
    
    MUL phi_1rh,modf_1r     	;2
      
    MOV zl,mul_l	    	;1
      
    LPM t1,Z		    	;3
    MUL t1,modg_1r          	;2
    MOV zl,phi_1rh     		;1
    ADD zl,mul_h		;1
    LPM	t1,Z			;3
    MUL t1,volume_1r		;2
    OUT OCR0,mul_h			;1
;                          ==========
;                               19 TZ
.endmacro


sound_init:
   LDI r17,0
   STS volume_1,r17
   ret

sound_playsound: ; r17 ton; r18 dauer; r19 Decay; r20 Klangfarbe
;r17 Bits 4-7 Oktave
;    Bits 0-3 Ton
;r18 Dauer in 20ms Schritten
;r19 Nachhall in 20 ms Schritten
    PUSH r21
    PUSH r22
    PUSH zl
    PUSH zh
	;Klangfarbe
	
	MOV r21,r20
	ANDI r21,$f0 ;Modulationsfrequenz
	SWAP r21
	STS modf_1,r21
	MOV r21,r20
	ANDI r21,$0f ;Modulationsgrad
	SWAP r21 ; damit grad staerker wird
	STS modg_1,r21
	
	;Tonhoehe
	LDI zh,high(sound_scale*2)
	LDI zl,low(sound_scale*2)
	
	MOV r21,r17 ;Ton holen
	ANDI r21,$0f ;maskieren
	;SWAP r21 ;verschieben
	
	ADD zl,r21
	ADD zl,r21
	LPM r21,Z+ ;low Byte
	LPM r22,Z  ;high Byte
	MOV zh,r17 ;Register recyclen
	SWAP zh
	ANDI zh,$0f
   sound_playsound_octave_loop:
	LSR r22
	ROR r21
	INC zh
	CPI zh,$0f
       BRLT sound_playsound_octave_loop
    ;frequenz steht in r21:r20 drin	
	;LDI r21,0
	;LDI r22,20
	STS omega_1,r21
	STS omega_1+1,r22
	;wenn Ton kuerzer als 4*20=80 ms, dann nicht anschwingen
	CPI r18,4
	BRLT sound_playsound_hold
     ;Anschwingen 80 ms
	LDI r21,7
	LDI r22,0
    sound_playsound_attack_loop:
	SUBI r22,-63
	STS volume_1,r22
	call sleep_frame
	DEC r21	
	BRNE sound_playsound_attack_loop
	SUBI r18,4
    sound_playsound_hold: ;Ton halten
        LDI r22,255
	STS volume_1,r22
	call sleep_frame
	DEC r18
	BRNE sound_playsound_hold 
    sound_playsound_decay: ;abklingen max 1s
        LDI r18,255
     sound_playsound_decay_loop:
        call sleep_frame
	SUBI r18,5
	BREQ sound_end
	STS volume_1,r18
	DEC r19
	BRNE sound_playsound_decay_loop
      sound_end:	
	;Ton aus
	LDI r18,0
	STS volume_1,r18
    POP zh
    POP zl
    POP r22
    POP r21	
ret    

sound_demo:
sound_demo2:
    LDI r22,0
    sound_demo2_start:
    LDI zh,high(sound_freude_schoener_goetterfunken*2)
    LDI zl,low(sound_freude_schoener_goetterfunken*2);
   sound_demo2_loop:
    LPM r23,Z+
    LDI r17,'-'
    call out_char_r17
    CPI r23,0
    BREQ sound_demo2_start
    MOV r24,r23
    ANDI r24,$7f
    LDI r17,$A0
    ADD r17,r24
    LDI r18,10
    LDI r19,12
    SBRC r23,7
    LDI r19,22
    MOV r20,r22
    call sound_playsound
    call get_key_r17
    CPI r17,27
    BREQ sound_demo2_ende
    CPI r17,'0'
    BRLT sound_demo2_loop
    CPI r17,'9'+1
    BRGE sound_demo2_loop
    MOV r22,r17
    call out_char_r17
    SUBI r22,'0'
    SWAP r22
    ORI r22,$06
    rjmp sound_demo2_loop
   sound_demo2_ende:    
ret
    

nop
nop
nop
nop

.cseg

sound_scale: ;wird in Intel-Richtung abgespeichert
.dw 17557,18601,19708,20879,22121,23436,24830,26306,27871,29528,31283,33144

sound_freude_schoener_goetterfunken:
.db $14,$14,$15,$17,$17,$15,$14,$12,$10,$10,$12,$14,$14,$12,$12+$80,  $14
.db     $14,$15,$17,$17,$15,$14,$12,$10,$10,$12,$14,$12,$10,$10+$80
.db $12+$80,$14,$10,$12,$14,$15,$14,$10,$14,$15,$14,$12,$10,$12
.db $7,$14,$15,$17,$17,$15,$14,$12,$10,$10,$12,$14,$12,$10,$90,0

