;#####################################################################################
;## 										    ##
;##	Textausgabe Routinen							    ##
;## 										    ##
;#####################################################################################

; Name			Geschrieben	Getestet	Dokumentiert
; clear_line_r17	OK
; clear_screen		OK
; scroll_up	
; out_char_r17
; text_cr_lf		OK


clear_line_r17: ;Loescht die Zeile in r17
    push xh
    push xl
    push r18
    push r19
    LDI	xh,high(line_pointers) 
    LDI	xl,low(line_pointers)  
    ADD xl,r17
    ADD xl,r17
    
    LD	r18,X+  ; low byte der Adresse
    LD r19,X    ; high byte der Adresse
    
;    ANDI r19,$0f ; hoechstes Nibble rausmaskieren
    
    MOV Xl,r18
    MOV xh,r19
    
    LDI r19,32 ; 32=Leerzeichen!!!
    LDI r18,40
  clear_line_r17_loop:
    ST	X+,r19
    DEC r18
    BRNE clear_line_r17_loop    
    
    pop r19
    pop r18
    pop xl
    pop xh
    ret
    
clear_screen: ; loescht den Bildschirm setzt Cursor auf 0:0
    push r17
    LDI r17,linecount
   clear_screen_loop:
    dec r17
    call clear_line_r17
    CPI	r17,0
    BRNE clear_screen_loop
    LDI r17,0  
    STS text_pos_x,r17
    STS text_pos_y,r17
    pop	 r17
    ret
    
scroll_up:  ; schiebt den Bildschirm nach oben
    push r17
    push r18
    push r19
    push r20
    push r21
    push Xl
    push Xh
    push yl
    push yh
      LDI xl,low(line_pointers)
      LDI xh,high(line_pointers)
      LDI yl,low(line_pointers)
      LDI yh,high(line_pointers)
      LD  r18,X+
      LD  r19,X+
      LDI r17,linecount-1
    scroll_up_next_line:
       LD  r20,X+    
       LD  r21,X+
       ST  Y+,r20
       ST  Y+,r21
       DEC r17
       CPI r17,0
       BRNE scroll_up_next_line   
      ST  Y+,r18
      ST  Y+,r19
    pop yh
    pop yl
    pop Xh
    pop Xl
    pop r21
    pop r20
    pop r19
    pop r18
    pop r17
    ret

scroll_down:  ; schiebt den Bildschirm nach unten
    push r17
    push r18
    push r19
    push r20
    push r21
    push Xl
    push Xh
    push yl
    push yh
      LDI xl,low(line_pointers+linecount*2)
      LDI xh,high(line_pointers+linecount*2)
      LD  r18,-X ;Adresse der untersten Zeile sichern
      LD  r19,-X
      LDI yl,low(line_pointers+linecount*2)
      LDI yh,high(line_pointers+linecount*2)
      LDI r17,linecount-1
    scroll_down_next_line:
       LD  r20,-X    
       LD  r21,-X
       ST  -Y,r20
       ST  -Y,r21
       DEC r17
       CPI r17,0
       BRNE scroll_down_next_line   
      ST  -Y,r18
      ST  -Y,r19
    pop yh
    pop yl
    pop Xh
    pop Xl
    pop r21
    pop r20
    pop r19
    pop r18
    pop r17
    ret

    
text_cr_lf: ; Wagenruecklauf Zeilenschaltung    
    PUSH r17
    LDI	r17,0
    STS	text_pos_x,r17 
    LDS	r17,text_pos_y
    inc r17
    CPI r17,20
    BRLT text_cr_lf_ende
    CPI r17,19
    call scroll_up
    LDI r17,0  
    STS text_pos_x,r17
    LDI	r17,linecount-1
    STS text_pos_y,r18
    call clear_line_r17
  text_cr_lf_ende:    
    STS text_pos_y,r17
    POP r17
    ret    

    
get_char_pointer_x: ;makes x point to the character position in memory
    PUSH r18
    PUSH yl
    PUSH yh
    
    LDS	r18,text_pos_y
    CPI r18, linecount
    BRLT get_char_pointer_x_Zeile_OK
    LDI r18,0
    get_char_pointer_x_Zeile_OK:
    LDI yh,high(line_pointers)
    LDI yl,low(line_pointers)
    ADD yl,r18
    ADD yl,r18 
    LD xl,Y+ 
    LD xh,Y
    LDS r18,text_pos_x
    ADD xl,r18
    
    POP yh
    POP yl
    POP r18
    ret    
    
    
out_char_r17: ;gibt Zeichen in r17 aus r17 bleibt erhalten
    PUSH xh
    PUSH xl
    
    call get_char_pointer_x
    
    ST	X,r17
    
    LDS xl,text_pos_x
    inc xl
    STS text_pos_x,xl
    
    CPI xl,40             ;Anzahl Spalten
    BRLT out_char_r17_end
    call text_cr_lf
  out_char_r17_end:    
    POP xl
    POP xh
    ret

get_char_r17: ;holt Zeichen auf Cursorposition. Aendert Position nicht
    PUSH xh
    PUSH xl
    call get_char_pointer_x
    LD r17,X
    POP xl
    POP xh
    ret
    
write_string_z_pm: ;Schreibt nullterminierte Zeichenkette im ROM, Zeiger in Z, steht dann auf 0-Byte
    PUSH r17
   write_string_z_pm_loop:    
      LPM r17,Z+
      CPI r17,0
      BREQ write_string_z_pm_ende
      call out_char_r17
      rjmp write_string_z_pm_loop
   write_string_z_pm_ende:      
    POP r17    
    ret

