;Keyboard routines

.equ kf1=128
.equ kf2=129
.equ kf3=130
.equ kf4=131
.equ kf5=132
.equ kf6=133
.equ kf7=134
.equ kf8=135
.equ kf9=136
.equ kf10=137
.equ kf11=138
.equ kf12=139
.equ kesc=27
.equ kret=13
.equ ktab=9
.equ kbsp=8
.equ kup=24
.equ kdown=25
.equ kleft=28
.equ kright=26
.equ kshift=1
.equ kalt=2
.equ kctr=3
.equ kcaps=4
.equ knum=5
.equ kscr=6



handle_keyboard_key_r17:
  ;shift state  76543210
  ;             |||||||+ shift
  ;             ||||||+
  ;          	|||||+
  ;		||||+
  ;		|||+
  ;		||+
  ;		|+
  ;		+ break code 
   push 	r18
    ;PUSH r17
    PUSH zh
    PUSH zl
    PUSH r20
    
    LDS r18,shift_state
    
;;;    call out_char_r17 ;;test
    
;;    cp r20,r17
    call insert_into_random_pool_r17
    
    CPI r17,$FA ;drop FAs
    BREQ keyboard_key_irq_handler_end
    
    CPI r17,$AA ;drop AAs
    BREQ keyboard_key_irq_handler_end
    
    CPI r17,$E0 ;drop E0s
    BREQ keyboard_key_irq_handler_end
    
    CPI r17,$f0 ;break code?
    BREQ keyboard_key_irq_handler_break_code
    ;get normal key
    mov r20,r18
    ANDI r20,$7f
    LDI zh,high(keycodes_shift*2)
    LDI	zl,low(keycodes_shift*2) 
    CPI r20,1
    BREQ keyboard_key_irq_handle_shift
    LDI zh,high(keycodes_normal*2)
    LDI	zl,low(keycodes_normal*2)    
   keyboard_key_irq_handle_shift:
    LDI r20,0
    add zl,r17  ;ueberlauf notwendig!
    adc zh,r20
    LPM r17,Z
    
    CPI r17,1 ;shift?
    BREQ keyboard_key_irq_handler_shift
    
    mov zl,r18
    ANDI zl,$80 ;break code
    CPI zl,$80
    BREQ keyboard_key_irq_handler_end    
;    CPI r17,kret
;    BREQ keyboard_key_irq_handler_return
;    call out_char_r17
    STS key_buffer,r17
    rjmp keyboard_key_irq_handler_end
   keyboard_key_irq_handler_return:
    call text_cr_lf
    rjmp keyboard_key_irq_handler_end
  keyboard_key_irq_handler_shift:    
    mov zl,r18
    ANDI zl,$80 ;break code
    CPI zl,$80
    BREQ keyboard_key_irq_handler_shift_off    
    LDI r18,1
    rjmp keyboard_key_irq_handler_end
   keyboard_key_irq_handler_shift_off:
    LDI r18,0 
    rjmp keyboard_key_irq_handler_end
  keyboard_key_irq_handler_break_code: ;break code
    ORI r18,$80
    rjmp keyboard_key_irq_handler_end2
  keyboard_key_irq_handler_end:
    ANDI r18,$7f ;break code off
  keyboard_key_irq_handler_end2:
    
    STS shift_state,r18
    POP r20
    POP zl
    POP zh
    ;POP r17
    
    pop	r18       
  ret


keyboard_key_irq_handler:
    PUSH 	r19
    IN	r19,SREG  
    PUSH r17 

    LDS r17,timer_counter
    call insert_into_random_pool_r17

  keyboard_key_irq_handler_start:
    in r17,UDR
;    in r17,SPDR  ;Input from SPI
     rcall handle_keyboard_key_r17	
    sbic  UCSRA,RXC ;still bytes in buffer?
    rjmp keyboard_key_irq_handler_start ;if yet do it again
    POP r17
    OUT	SREG,r19
    POP	r19
  reti


















get_key_r17: ;gets the current key in r17
    LDS r17,key_buffer
    CPI r17,0
    BREQ get_key_r17_end ; exit when no key is pressed
    PUSH r17
      LDI r17,0
      STS key_Buffer,r17
    POP r17
    get_key_r17_end:
  ret

read_line_x_r18: ;reads/edits the line at RAM position x, max length in r18
   PUSH r17
   PUSH yl    
   PUSH yh
   push zl
   push zh
   PUSH r19    ; character under cursor + temp
   PUSH r20    ;Position 0.. r18-1
   PUSH r21    ;temp register
   mov yl,xl
   mov yh,xh
   LDI r20,0
  read_line_x_r18_start: 
   mov yh,xh ;Put Y to the current char
   mov yl,xl
   add yl,r20
        
   LD r19,Y
   read_line_x_r18_waitkeyloop:
      LDS r21,time
      ANDI r21,8
      LDI r17,'_'
      CPI r21,0
      BREQ read_line_x_r18_nocursor
        ST Y,r17
      read_line_x_r18_nocursor:	
      call get_key_r17
      ST Y,r19
      CPI r17,0
     BREQ read_line_x_r18_waitkeyloop
   CPI r17,kret        ; Enter Taste?
   BREQ read_line_x_r18_end ;  dann raus
   CPI r17,kbsp        ; Rueckschritt Taste?
   BREQ read_line_x_r18_backspace
   CPI r17,kleft
   BREQ read_line_x_r18_kleft ;Taste links

   CP r20,r18 ; right border
   BREQ read_line_x_r18_start ; ignore key press
   CPI r17,kright
   BREQ read_line_x_r18_kright ; Taste rechts     
   ; normale Taste
   inc r20
   ST Y,r17
   rjmp read_line_x_r18_start     
     
  read_line_x_r18_backspace:
   CPI r20,0                 ; ganz links
   BREQ read_line_x_r18_start ; dann raufspringen
   mov zh,yh ;Put Z to the current char
   mov zl,yl
   subi zl,1 ; Put Z to char left of cursor
   mov r21,r20
   dec r20 ;move sursor to the left
  read_line_x_r18_backspace_loop: 
   LD r19,Y+
   ST Z+,r19
   inc r21
   CP r18,r21 ;If you have moved to the last character stop
   BRLT read_line_x_r18_backspace_end      
   CPI r19,0   ;                       Keine Null
   BRNE read_line_x_r18_backspace_loop ; Nochmal
   read_line_x_r18_backspace_end:
   LDI r19,0
   ST Z,r19 ; fill up with 0     
  rjmp read_line_x_r18_start; go up again     
  read_line_x_r18_kleft:
   CPI r20,0    ; left border
   BREQ read_line_x_r18_start ;go up again
   dec r20
   rjmp read_line_x_r18_start
  read_line_x_r18_kright:
    inc yl
    LD r19,Y
    CPI r19,0
    BREQ read_line_x_r18_start ;won't go to zerocharacter
    inc r20
    rjmp read_line_x_r18_start     
  rjmp read_line_x_r18_start
  read_line_x_r18_end:
   POP r21
   POP r20
   POP r19
   POP zh
   POP zl
   POP yh
   POP yl
   POP r17
  ret
  