; All routines which are responsible for sync-signals

.macro sleep_r17 ; wartet r17*4-1 TZ
     sleep_r17_loop:
      DEC r17 ; 1 TZ
      CPI r17,0 ;1 TZ
      BRNE sleep_r17_loop ;2 TZ
.endmacro

.macro syncein ;2 TZ
;     CBI PORTC,5
	CBI	sync,sync_b
;      LDI r5,255
;      NOP
;      OUT portc,r5
.endmacro

.macro syncaus ;2TZ
;     SBI PORTC,5
	SBI	sync,sync_b
;      LDI r5,255
;      NOP
;      OUT portc,r5
.endmacro

.macro syncimpuls ;laenge in r17 in TZ/4
    syncein
    sleep_r17
    syncaus
.endmacro

.macro hsync ; 44
    LDI r17,hsynclen/4
    syncimpuls
.endmacro 



;Interrupthandler Dokumentation:
; M   C
; 5   5 mal Vortrabenten
; 4   5 mal Synchronisier-Impulse
; 6   5 mal Nachtrabanten
; 1   X mal jeden zweiten Interrupt
; 3   160 Zeilen (bei 20 Textzeilen)
; 2   X mal jeden zweiten Interrupt

timer_handler_4_times_per_line:
	push 	r18
	PUSH 	r19
	IN	r19,SREG
	;cli
	;sei
	LDS	r18,timer_counter
	inc	r18
	STS	timer_counter,r18
	ANDI	r18,3
	CPI	r18,0
	BRNE	timer_handler_4_times_per_line_end
	call	sync_once_per_line
	
   timer_handler_4_times_per_line_end:	
        
	;sei
	OUT	SREG,r19
	POP	r19
	pop	r18
	reti




sync_once_per_line:
   audio_isr_prepare
   PUSH r17
   LDS r17,line_counter	
   inc r17
   STS line_counter,r17
   cpi r17,image_position
   brne sync_once_per_line_2
   call drawimage
   call count_time
   call count_realtime_clock_50Hz
   rjmp sync_once_per_line_end
  sync_once_per_line_2:
   cpi r17,image_linecount ;line end
   brne sync_once_per_line_empty_line
   LDI r17,0
   STS line_counter,r17
   call sync_vsync
  sync_once_per_line_empty_line:
   hsync
   PUSH zl
   PUSH zh
   audio_pm_15625Hz
   POP zh
   POP zl 
  sync_once_per_line_end:
   POP r17
   audio_isr_finish
  ret



sync_trabant: ; rcall 3 TZ insgesammt 512 TZ
  syncein      ;2
  LDI r17, 10  ;1
  sleep_r17   ;39
  syncaus      ;2
  LDI r17,115
  sleep_r17
  nop
 ret          ;4

sync_trabant_kurz: ; rcall 3 TZ insgesammt 512 TZ
  syncein      ;2
  LDI r17, 10  ;1
  sleep_r17   ;39
  syncaus      ;2
  LDI r17,115-8
  sleep_r17
  nop
 ret          ;4


sync_vsyncpulse:  ;rcall 3 TZ insgesammt 512 TZ
  syncein      ;2
  LDI r17, 108  ;1
  sleep_r17   ;39
  syncaus      ;2
  LDI r17,18
  sleep_r17
  nop
 ret
 
sync_vsyncpulse_kurz:  ;rcall 3 TZ insgesammt 512 TZ
  syncein      ;2
  LDI r17, 108-8  ;1
  sleep_r17   ;39
  syncaus      ;2
  LDI r17,18
  sleep_r17
  nop
 ret

sync_vsync: ;complete vsync
  rcall sync_trabant
  rcall sync_trabant_kurz

 rcall sync_pm

  rcall sync_trabant
  rcall sync_trabant_kurz
  
 rcall sync_pm
 
  rcall sync_trabant
  rcall sync_vsyncpulse_kurz
  
 rcall sync_pm
 
  rcall sync_vsyncpulse
  rcall sync_vsyncpulse_kurz
  
 rcall sync_pm
 
  rcall sync_vsyncpulse
  rcall sync_vsyncpulse_kurz
  
 rcall sync_pm
 
  rcall sync_trabant
  rcall sync_trabant_kurz
  
 rcall sync_pm
 
  rcall sync_trabant
  rcall sync_trabant_kurz
  
 rcall sync_pm
 
  rcall sync_trabant
 ret
 	
sync_pm:
   PUSH zl
   PUSH zh
   audio_pm_15625Hz
   nop
   POP zh
   POP zl 
  ret