;.include "m16def.inc"

.org 0x0
    RJMP  start
    
.org OVF0addr
rjmp timer_handler_4_times_per_line

;.org SPIaddr
.org URXCaddr
jmp keyboard_key_irq_handler
;reti

.equ linecount=20 ;wird nicht ueberall benutzt
.equ hsynclen=40 ; (256 TZ)
.equ vsynclen=432 ; (256 TZ)
.equ trabantlen=40
.equ linelen=1024; (1024 TZ)
.equ synclines=50; Zeilen vor Bild um Jitter auszugleichen
.equ verschieben_v=-50;Positiv-> nach unten

.equ image_position=40
.equ image_linecount=312-8-linecount*8-synclines

.equ video=PORTA
.equ sync=PORTC
.equ sync_b=0






.org $013
reti
.org $020
start:
    ; Stack Pointer setzen
    LDI	r17, low(RAMEND)  
    OUT	SPL,r17
    LDI	r17, high(RAMEND)
    OUT	SPH,r17
    ;Portrichtungen setzen
    LDI	r17,1 ; Bit 0 auf Ausgang, Rest auf Eingang
    OUT	DDRA,r17
    LDI	r17,(1<<sync_b) ; Bit 5 auf Ausgang, 
;    LDI r17,255
    OUT	DDRC,r17
    
    ;Cursor auf 0:0
    LDI r18,0  
    STS text_pos_x,r18
    STS text_pos_y,r18
    
    ;Line_pointers setzen
    LDI	xh,high(line_pointers)
    LDI	xl,low(line_pointers)

    LDI r17,low(line_00)
    st	X+,r17
    LDI	r17,high(line_00);
    st X+,r17
    
    LDI r17,low(line_01)
    st	X+,r17
    LDI	r17,high(line_01);
    st X+,r17
    
    LDI r17,low(line_02)
    st	X+,r17
    LDI	r17,high(line_02);
    st X+,r17
    
    LDI r17,low(line_03)
    st	X+,r17
    LDI	r17,high(line_03);
    st X+,r17
    
    LDI r17,low(line_04)
    st	X+,r17
    LDI	r17,high(line_04);
    st X+,r17
    
    LDI r17,low(line_05)
    st	X+,r17
    LDI	r17,high(line_05);
    st X+,r17
    
    LDI r17,low(line_06)
    st	X+,r17
    LDI	r17,high(line_06);
    st X+,r17
    
    LDI r17,low(line_07)
    st	X+,r17
    LDI	r17,high(line_07);
    st X+,r17
    
    LDI r17,low(line_08)
    st	X+,r17
    LDI	r17,high(line_08);
    st X+,r17
    
    LDI r17,low(line_09)
    st	X+,r17
    LDI	r17,high(line_09);
    st X+,r17
    
    LDI r17,low(line_10)
    st	X+,r17
    LDI	r17,high(line_10);
    st X+,r17
    
    LDI r17,low(line_11)
    st	X+,r17
    LDI	r17,high(line_11);
    st X+,r17
    
    LDI r17,low(line_12)
    st	X+,r17
    LDI	r17,high(line_12);
    st X+,r17
    
    LDI r17,low(line_13)
    st	X+,r17
    LDI	r17,high(line_13);
    st X+,r17
    
    LDI r17,low(line_14)
    st	X+,r17
    LDI	r17,high(line_14);
    st X+,r17
    
    LDI r17,low(line_15)
    st	X+,r17
    LDI	r17,high(line_15);
    st X+,r17
    
    LDI r17,low(line_16)
    st	X+,r17
    LDI	r17,high(line_16);
    st X+,r17
    
    LDI r17,low(line_17)
    st	X+,r17
    LDI	r17,high(line_17);
    st X+,r17
    
    LDI r17,low(line_18)
    st	X+,r17
    LDI	r17,high(line_18);
    st X+,r17
    
    LDI r17,low(line_19)
    st	X+,r17
    LDI	r17,high(line_19);
    st X+,r17
    
    ;timer auf alle 256 TZ setzen	
    ;LDI	r17,1; TCCR0 CS02:0 kein Vorteiler
    LDI r17,$79 ;kein Vorteiler Fast PWM-Modus
    OUT	TCCR0,r17
    
    ;Timer Ausgangspin PB3 aktivieren
    LDI r17,8
    OUT DDRB,r17
    
    call sound_init
    
    ;Versuch mit Timer 2
    ;LDI r17,0
    ;OUT ASSR,r17
    
    ;LDI r17,$79
    ;OUT TCCR2,r17
    
    
    
    
    LDI	r17,1 ;TOIE0 Timer0 Overflow Interrupt Enable
    OUT	TIMSK,r17
    
    LDI r17,0 ;
    OUT	GICR,r17; Keine externen Interrupts.
    
    ;Stromspaarmodus (geht noch nicht!)
    IN r17,MCUCR
    ANDI r17,0x0f ;SE -SM0 ausmaskieren
    ORI	r17,0x80 ;einschalten Modus idle
    OUT	MCUCR,r17 
    
    
    ;Tastaturinit allgemein
    LDI r17,0
    STS shift_state,r17
    STS key_buffer,r17
    ;Tastaturinit usart
    LDI r17,$00 ;Statusregister, so dass U2x=0 ist
    OUT UCSRA,r17
    LDI r17,(1<<rxen)+(1<<rxcie)
    OUT UCSRB,r17 ; Empfangsinterrupt und Empfang einschalten
    LDI r17,$f6;+(1<<ursel) ; Synchoner Modus 8 Bit Paritaet
    OUT UCSRC,r17
    LDI	r17,0 ; Bit 0 und 4 auf Eingang 
    OUT	DDRD,r17

   ;Tastaturinit SPI
    ;LDI r17,$E8
    ;OUT SPCR,r17    
    
    call init_realtime_clock

        
    sei ;Interrupts global freischalten

    LDI r17,255
    mov r5,r17
    
    
    
    
    jmp	main ; zu main springen
    ;Testprogramm nach main
    
    LDI r17,0
    test:
      inc r17
      out Portb,r17
    rjmp test





.include "ram.asm"
.include "audio.asm"
.include "sync.asm"
.include "char_gen.asm"
.include "crt_controll.asm"
.include "keyboard.asm"
.include "keycodes.asm"
.include "utils.asm"
.include "realtime_clock.asm"
    



    
count_time: ;to be called 50 times a second
    PUSH	r17
    LDS		r17,time
    inc		r17
    STS		time,r17
    POP		r17
    ret
    

sleep_frame: ;sleeps till the start of the next frame
     PUSH r18
     PUSH r17
      LDS r18,time
     sleep_frame_loop:
      sleep
      LDS r17,time
      CP r17,r18 
      BREQ sleep_frame_loop
     POP r17
     POP r18
    ret

sleep_01s: ;sleeps for 0.1 seconds; 5 frames
     call sleep_frame
     call sleep_frame
     call sleep_frame
     call sleep_frame
     call sleep_frame
    ret
    

insert_into_random_pool_r17:
     PUSH r18
      LDS r18,random_numberl
      EOR r18,r17
      STS random_numberl,r18
     POP r18
   ret


get_random_number_r17: ;besorgt eine beliebige Zahl
			; Methode der additiven Kongruenz
    PUSH r18
    PUSH r19
    PUSH r20
    ;LDI r20,0
    LDS r17,random_numberl
    LDS r18,random_numberh
    MOV r20,r17
    ROL r17
    ROL r18
    ADC r17,r20
    STS random_numberl,r17
    STS random_numberh,r18
    POP r20
    POP r19
    POP r18
  ret 

hexdigit_to_ascii_r17: ;changes the hex digit in the lower 4 bits of r17 to it's ASCII representation
    andi r17,$0f
    subi r17,$ff-$2f ;0-9
    CPI r17,$3A
    BRLT hexdigit_to_ascii_end
    subi r17,$ff-6 ; A-F
    hexdigit_to_ascii_end:
  ret


display_byte_hex_r17:
    PUSH r19
     mov r19,r17
     swap r19
     mov r17,r19
     call hexdigit_to_ascii_r17
     call out_char_r17
     swap r19
     mov r17,r19
     call hexdigit_to_ascii_r17
     call out_char_r17
    POP r19
  ret


  

;#### Hauptprogramm###
;.include	"main.asm" ; main.asm enthaelt Hauptprogramm
libtop:



;Sinustabelle 256 bytes vor Zeichensatz
.org (FLASHEND-(8*256)/2+1)-$100
.include "sintab.asm"

;Zeichensatz 256 Zeichen a 8x8    
;.org 6144 ;2 Kilobyte vor Ende des ROMs    
.org FLASHEND-(8*256)/2+1
.include "char_rom.asm"    

.org libtop
